/* 
 * File:   Seq.cpp
 * Author: lx
 * 
 * Created on December 5, 2009, 8:27 PM
 */

#include "Seq.h"

Seq::Seq() {
}

Seq::Seq(const Seq& orig) {
}

Seq::~Seq() {
}

// flag = 0: short reads file; 1: quality file
void Seq::retrieve_seqs_from_fa(bIO::FASTA_input& handle, int max, bool flag){     

    typedef bIO::FASTA_input::value_type value_type;

    int position = 0;
    int num = 0;
    
    while (++ handle == true) {

            const value_type& v = *handle;

            if (!flag){
                SL_.push_back(position);

                S_.resize(S_.size() + v.second.length() + 1);

                memcpy(&S_[position], v.second.c_str(), v.second.length() + 1);

                position += v.second.length() + 1;
            }
            else {
                QL_.push_back(position);

                std::string quals = v.second;

                quals.erase(0, 1);

                Q_.resize(Q_.size() + quals.length() + 1);

                memcpy(&Q_[position], quals.c_str(), quals.length() + 1);

                position += quals.length() + 1;
                
            }     

            num ++;
            
            if (num >= max) break;
    }
    //converting everything to lower case
    if (!flag){
        for (int i = 0; i < (int) S_.size(); ++ i){
            if(isupper(S_[i])) {
                S_[i] = tolower(S_[i]);
            }
        }
    }

}


void Seq::qualHist(const Para& myPara){

    for (int i = 0; i < QL_.size(); ++ i){

        int pos = QL_[i];

        int len = (int) strlen(&Q_[pos]);

        // the first position of quality score is added a '@', need to be ignored
        for (int j = 1; j < len; ++ j){

            int score = (int) Q_[pos + j];
            iu64map_t::iterator it = score2cnt_.find(score);
            if (it != score2cnt_.end()){
                score2cnt_[score] ++;
            }
            else{
                score2cnt_[score] = 1;
            }

        }
    }
    /*
    int newThreshold = prefix_sum (score2cnt_, myPara.maxER);
    if (myPara.qualThreshold == 0){
        myPara.qualThreshold = newThreshold;
    }
    */
}



/*
// flag: true -- reads
// flag: false -- quality scores
void Seq::retrieve_seqs_from_fa(const std::string& filename, bool flag){

    bIO::FASTA_input fasta_in (filename.c_str());

    typedef bIO::FASTA_input::value_type value_type;

    int position = 0;

    while (++ fasta_in == true) {

            const value_type& v = *fasta_in;

            if (flag){
                SL_.push_back(position);

                S_.resize(S_.size() + v.second.length() + 1);

                memcpy(&S_[position], v.second.c_str(), v.second.length() + 1);
            }
            else {
                QL_.push_back(position);

                Q_.resize(Q_.size() + v.second.length() + 1);

                memcpy(&Q_[position], v.second.c_str(), v.second.length() + 1);
            }

            position += v.second.length() + 1;

    }
    //converting everything to lower case
    if (flag){
        for (int i = 0; i < (int) S_.size(); ++ i){
                if(isupper(S_[i])) {
                        S_[i] = tolower(S_[i]);
                }
        }
    }
    if(!SL_.size() && !QL_.size()) {
        std::cout << "nothing has been readed from " << filename << std::endl;
        exit(1);
    }
}

 
int Seq::prefix_sum (const imap_t& s2cnt, const double& errRate){

    int threshold = -1;
    ivec_t sum;
    sum.reserve(s2cnt.size());

    int prefix = 0;

    for (imap_t::const_iterator it = s2cnt.begin(); it != s2cnt.end(); ++ it){
        prefix += (*it).second;
        sum.push_back(prefix);
    }

    int cnt = 0;

    std::cout << "\nQuality Score Histogram\n";
    std::cout << "----------------------------\n";
    std::cout << std::endl;
    for (imap_t::const_iterator it = s2cnt.begin(); it != s2cnt.end(); ++ it){

        double err = (double) sum[cnt]/sum.back();

        if (err <= errRate) threshold = (*it).first;

        std::cout << (*it).first << "\t" << (*it).second
                  << "\t" << err << "\n" ;
        cnt ++;
    }
    std::cout << "----------------------------\n";

    return threshold;
}
*/
