/* 
 * File:   Seq.h
 * Author: lx
 *
 * Created on December 5, 2009, 8:27 PM
 */

#ifndef _SEQ_H
#define	_SEQ_H

#include "util.h"
#include "fasta_file.hpp"

class Seq {

protected:
    cvec_t S_;              // full string
    ivec_t SL_;             // location of each read
    cvec_t Q_;              // quality string
    ivec_t QL_;
    iu64map_t score2cnt_;
    int prefix_sum (const imap_t&, const double&);
    
public:
    Seq();
    Seq(const Seq& orig);
    virtual ~Seq();
    void retrieve_seqs_from_fa(const std::string& filename, bool flag);

    void retrieve_seqs_from_fa(bIO::FASTA_input& handle, int max, bool flag);
    
    void qualHist(const Para& myPara);
    const cvec_t& getS () const {
        return S_;
    }
    const ivec_t& getSL() const {
        return SL_;
    }
    const cvec_t& getQ () const {
        return Q_;
    }
    const ivec_t& getQL() const {
        return QL_;
    }
    const iu64map_t& getS2C () const {
        return score2cnt_;
    }
    void clear() {
        S_.clear(); SL_.clear(); Q_.clear(); QL_.clear(); score2cnt_.clear();
    }
};

#endif	/* _SEQ_H */

